"""
Autogenerated module using `pop-create-idem <https://gitlab.com/saltstack/pop/pop-create-idem>`__
"""


async def products(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    List of all the products that are available for purchase.

    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.subscription.products(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.subscription.products org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/subscriptions/products".format(**{"org": org}),
        query_params={},
        data={}
    )


async def offer_instances(hub, ctx, org: str, region: str, product_type: str, product: str = None, type: str = None) -> None:
    """
    **Autogenerated function**
    
    List all offers available for the specific product type in the specific region

    Args:
        org(str): Organization identifier.
        region(str): Region for the offer.
        product_type(str): Type of the product in offers. *This has been deprecated*. Please use product & type parameters.
        product(str, optional): The product that you are trying to purchase, eg. host. This needs to be accompanied by the type parameter. Defaults to None.
        type(str, optional): The type/flavor of the product you are trying it purchase,eg. an `r5.metal` host.
This needs to be accompanied by the product parameter.
. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.subscription.offer_instances(ctx, org=value, region=value, product_type=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.subscription.offer_instances org=value, region=value, product_type=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/subscriptions/offer-instances".format(**{"org": org}),
        query_params={"region": region, "product_type": product_type, "product": product, "type": type},
        data={}
    )


async def subscription(hub, ctx, org: str, subscription: str) -> None:
    """
    **Autogenerated function**
    
    Get subscription details for a given subscription id

    Args:
        org(str): Organization identifier.
        subscription(str): SubscriptionId for an sddc.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.subscription.subscription(ctx, org=value, subscription=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.subscription.subscription org=value, subscription=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/subscriptions/{subscription}".format(**{"org": org, "subscription": subscription}),
        query_params={},
        data={}
    )


async def subscriptions(hub, ctx, org: str, offer_type: str = None) -> None:
    """
    **Autogenerated function**
    
    Returns all subscriptions for a given org id

    Args:
        org(str): Organization identifier.
        offer_type(str, optional): Offer Type
 * `ON_DEMAND` - on-demand subscription
 * `TERM` - term subscription
 * All subscriptions if not specified
. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.subscription.subscriptions(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.subscription.subscriptions org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/subscriptions".format(**{"org": org}),
        query_params={"offer_type": offer_type},
        data={}
    )


async def subscription_request(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Initiates the creation of a subscription

    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.subscription.subscription_request(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.subscription.subscription_request org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/subscriptions".format(**{"org": org}),
        query_params={},
        data={}
    )

